VERSION 5.00
Begin VB.Form MainForm 
   Caption         =   "TagDemo V2.01"
   ClientHeight    =   1845
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6780
   LinkTopic       =   "Form1"
   ScaleHeight     =   1845
   ScaleWidth      =   6780
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton WriteEnum 
      Caption         =   "Write Enum"
      Height          =   615
      Left            =   5160
      TabIndex        =   5
      Top             =   1080
      Width           =   1575
   End
   Begin VB.CommandButton WriteFF 
      Caption         =   "Write FF's"
      Height          =   615
      Left            =   3480
      TabIndex        =   4
      Top             =   1080
      Width           =   1575
   End
   Begin VB.CommandButton Write00 
      Caption         =   "Write 00's"
      Height          =   615
      Left            =   1800
      TabIndex        =   3
      Top             =   1080
      Width           =   1575
   End
   Begin VB.Frame Frame1 
      Caption         =   "State"
      Height          =   855
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   6615
      Begin VB.Label stResult 
         Alignment       =   2  'Zentriert
         Caption         =   "?"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   360
         Width           =   6375
      End
   End
   Begin VB.CommandButton Read 
      Caption         =   "Read"
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   1080
      Width           =   1575
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
Dim Error As Long
' Search Reader on COM1 and COM2
Error = T4Init("COM1:")
If Error <> T4_NOERROR Then Error = T4Init("COM2:")

If Error <> T4_NOERROR Then
  stResult.Caption = "Error During Init (" + Str(Error) + ")"
  Exit Sub
End If
Error = T4ConfigurationReset()
If Error <> T4_NOERROR Then
  stResult.Caption = "Error During Init (" + Str(Error) + ")"
  Exit Sub
End If
' Prepare for a set of transponders (this is also the default config)
Error = T4SetTagDriver(T4_MSK_IDRO_A Or T4_MSK_IDRW_B Or T4_MSK_IDRW_C Or T4_MSK_IDRW_D)
If Error <> T4_NOERROR Then
  stResult.Caption = "Error During Init (" + Str(Error) + ")"
  Exit Sub
End If
stResult.Caption = "Init Successful"
End Sub

Private Sub Form_Unload(Cancel As Integer)
T4DeInit
End Sub

Private Function SearchTag() As Boolean
Dim Error As Long
Dim PassWord(1 To 4) As Byte
Dim TagType As Byte
Dim SerialNumber(1 To 5) As Byte
PassWord(1) = 0
PassWord(2) = 0
PassWord(3) = 0
PassWord(4) = 0
Error = T4SelectTagPW(PassWord(1), TagType, SerialNumber(1))
If Error = T4_NOERROR Then
  If TagType = T4_TYPE_IDRO_A Then stResult.Caption = "Found tag IDRO-A"
  If TagType = T4_TYPE_IDRW_B Then stResult.Caption = "Found tag IDRW-B"
  If TagType = T4_TYPE_IDRW_C Then stResult.Caption = "Found tag IDRW-C"
  If TagType = T4_TYPE_IDRW_D Then stResult.Caption = "Found tag IDRW-D"
  If TagType = T4_TYPE_IDRW_E Then stResult.Caption = "Found tag IDRW-E"
  SearchTag = True
Else
  If Error = T4_NOTAG Then
    stResult.Caption = "No Tag Found"
  Else
    stResult.Caption = "Communication Error (" + Str(Error) + ")"
  End If
  SearchTag = False
End If
End Function

Private Function ReadTagData() As Boolean
Dim Error As Long
Dim i As Integer
Dim Tagdata(1 To 16) As Byte
Dim Caption As String
' Read 4 words ( = 16 byte) from the tag beginning from adress 0
stResult.Caption = "Reading..."
Refresh
Error = T4ReadData(0, 4, Tagdata(1))
If Error = T4_NOERROR Then
  ' Display first 4 byte
  Caption = "Data: " + Str(Tagdata(1))
  For i = 2 To 16
    Caption = Caption + " " + Str(Tagdata(i))
  Next i
  stResult.Caption = Caption
  ReadTagData = True
Else
  stResult.Caption = "Read Error (" + Str(Error) + ")"
  ReadTagData = False
End If
End Function

Private Function WriteTagData(ByRef Tagdata() As Byte) As Boolean
Dim Error As Long
' Read 4 words ( = 16 byte) from the tag beginning from adress 0
stResult.Caption = "Writing..."
Refresh
Error = T4WriteData(0, 4, Tagdata(1))
If Error = T4_NOERROR Then
  ' Display first 4 byte
  stResult.Caption = "Write successful"
  WriteTagData = True
Else
  stResult.Caption = "Write Error (" + Str(Error) + ")"
  WriteTagData = False
End If
End Function

Private Sub Read_Click()
' Search for tag
If Not SearchTag Then
  Exit Sub
End If
If Not ReadTagData() Then
  Exit Sub
End If
' Do something senseful
End Sub

Private Sub Write00_Click()
Dim i As Integer
Dim Tagdata(1 To 16) As Byte
' Search for tag
If Not SearchTag Then
  Exit Sub
End If
For i = 1 To 16
  Tagdata(i) = 0
Next i
If Not WriteTagData(Tagdata) Then
  Exit Sub
End If
' Do something senseful
End Sub

Private Sub WriteFF_Click()
Dim i As Integer
Dim Tagdata(1 To 16) As Byte
' Search for tag
If Not SearchTag Then
  Exit Sub
End If
For i = 1 To 16
  Tagdata(i) = 255
Next i
If Not WriteTagData(Tagdata) Then
  Exit Sub
End If
' Do something senseful
End Sub

Private Sub WriteEnum_Click()
Dim i As Integer
Dim Tagdata(1 To 16) As Byte
' Search for tag
If Not SearchTag Then
  Exit Sub
End If
For i = 1 To 16
  Tagdata(i) = i
Next i
If Not WriteTagData(Tagdata) Then
  Exit Sub
End If
' Do something senseful
End Sub

